L=length(t);

[RDL RDLd cRD]=RDProf(x);

%total unit cost
[D cumprod]=myprod(x);

Ctot1=zeros(1,80);
for l=1:80
if D(l)>0

   Ctot1(l)=k*cRD(l).^A*cumprod(l).^B;
else
    Ctot1(l)=k*cRD(l).^A;
end
end
Ctot=[(Ctot1(1)+k)/2 (Ctot1(2:end)+Ctot1(1:end-1))/2];
%total revenus
%Rev=x(2)*D;
Rev=x(1:80).*D;

%total R&D
discRD_total=sum(RDL./(1+i).^t);
%total production cost
tprodcst=Ctot.*D;
%plant rent
pRnt=CI*D;
%FICA credits
    FICA=0.0403*RDL;
    FICA(21:end)=0;
%before tax cash flow
CshFlow=(Rev-tprodcst-pRnt-RDL+FICA);
%loss carry forward
LCF=min([CshFlow;zeros(1,L)]);
%cumulative taxable profit
Ctp=max([cumsum(CshFlow); zeros(1,L)]);
%taxable income by year
TaxIncY=[Ctp(1), Ctp(2:end)-Ctp(1:end-1)];
%tax paid & discount taxs paid before credit
TaxPd=TaxIncY*taxr;
%R&D tax credit
RDTxCred=[RDLd(1:3).*0.12,RDLd(4:end).*0.14];
RDTxCred=RDTxCred-FICA;
%tax paid & discount taxs paid after credit
TaxPdwC(1)=max(0,TaxPd(1)-RDTxCred(1));
CredCF(1)=max(0,RDTxCred(1)-TaxPd(1));
for j=2:80
CredCF(j)=max(0,RDTxCred(j)+CredCF(j-1)-TaxPd(j));
TaxPdwC(j)=max(0,TaxPd(j)-RDTxCred(j)-CredCF(j-1));
end
%total discount CF with credit
discCFwC=(CshFlow-TaxPdwC)./(1+i).^t;
%present value
PV=-sum(discCFwC);
%real credit
Real_Credit(1)=FICA(1);
for m=2:80
if CredCF(m)>0
    Real_Credit(m)=TaxPd(m)+FICA(m);
else
    Real_Credit(m)=RDTxCred(m)+CredCF(m-1)+FICA(m);
end
end
%total tax credit
ToTaxC=sum(Real_Credit./(1+i).^t);
%calculate the consumer surplus
Price=[zeros(1,T-1),x(T:80)];
W=6.5.*ones(1,80);
CS=(W-Price).*D/2;
disc_CS=CS./(1+i).^(t);
%Total CS
TotalCS=sum(disc_CS);
